importPackage(Packages.logbook.constants);

function hasTaihaInFleet(nowhp, maxhp) {
	if ((nowhp == null) || (maxhp == null)) {
		return false;
	}
	for (var i = 0; i < nowhp.length; ++i) {
		var rate = nowhp[i] / maxhp[i];
		if (rate <= AppConstants.BADLY_DAMAGE) {
			return true;
		}
	}
	return false;
}

function header() {
	return ["大破艦", "旗艦", "旗艦(第二艦隊)", "MVP", "MVP(第二艦隊)"];
}

function begin() { }

function body(battle) {
	var ret = java.lang.reflect.Array.newInstance(java.lang.Comparable, 5);
	// 大破艦があるか
	var lastPhase = battle.getLastPhase();
	var taiha = (hasTaihaInFleet(lastPhase.getNowFriendHp(), battle.getMaxFriendHp()) ||
			hasTaihaInFleet(lastPhase.getNowFriendHpCombined(), battle.getMaxFriendHpCombined()));
	ret[0] = taiha ? "あり" : null;

	// 旗艦
	ret[1] = battle.getDock().getShips().get(0).getFriendlyName();
	if (battle.isCombined()) {
		ret[2] = battle.getDockCombined()
				.getShips().get(0).getFriendlyName();
	}

	// MVP
	if (battle.getMvp() != -1) { // 敗北Eの時はMVPなし
		ret[3] = battle.getDock().getShips().get(battle.getMvp() - 1).getFriendlyName();
	}
	if (battle.isCombined()) {
		if (battle.getMvpCombined() != -1) { // 敗北Eの時はMVPなし
			ret[4] = battle.getDockCombined().getShips()
					.get(battle.getMvpCombined() - 1).getFriendlyName();
		}
	}
	return ret;
}

function end() { }
