importPackage(java.lang);

// javascriptの配列をそのまま返すと遅いので
// Comparable[]に変換しておく
// undefinedはnullに変換される
function toComparable(raw) {
	var ret = java.lang.reflect.Array.newInstance(java.lang.Comparable, raw.length);
	for(var i=0; i<raw.length; ++i) {
		if(raw[i] == null) {
			ret[i] = null;
		}
		else {
			ret[i] = raw[i].toString();
		}
	}
	return ret;
}

function header() {
	return [ "改修" ];
}

function begin() { }

function body(data) {
	var count = {};
	for each(var item in data.items.toArray()) {
		if(count[item.level] == null) {
			count[item.level] = 1;
		}
		else {
			count[item.level]++;
		}
	}
	var levels = [];
	for(var key in count) {
		levels.push(key);
	}
	// 降順ソート
	levels.sort(function(a,b) { return -(a - b); });

	if(levels[0] == 0) return null;

	var sb = new StringBuilder();
	for(var i=0; i<levels.length; ++i) {
        if (i != 0) {
            sb.append(",");
        }
		var level = levels[i];
		if(level == 0) {
			sb.append("無x");
		}
		else {
			sb.append("★").append(level).append("x");
		}
		sb.append(count[level]);
	}
	return toComparable([ sb.toString() ]);
}

function end() { }
