importPackage(Packages.org.eclipse.swt.widgets);
importPackage(Packages.org.eclipse.swt);
importPackage(Packages.org.eclipse.wb.swt);
importPackage(Packages.logbook.data.context);
importPackage(Packages.logbook.constants);
importPackage(Packages.logbook.util);

// javascriptの配列をそのまま返すと遅いので
// Comparable[]に変換しておく
// undefinedはnullに変換される
function toComparable(raw) {
	var ret = java.lang.reflect.Array.newInstance(java.lang.Comparable, raw.length);
	for(var i=0; i<raw.length; ++i) {
		if(raw[i] == null) {
			ret[i] = null;
		}
		else {
			ret[i] = raw[i].toString();
		}
	}
	return ret;
}

var condIndex = 12;
function begin(header) {
    missionShips = GlobalContext.getMissionShipSet();
    ndockShips = GlobalContext.getNDockShipSet();
    for (var i = 1; i < header.length; ++i) {
        if (header[i].equals("疲労")) {
            condIndex = i;
            break;
        }
    }
}

function getTableCondColor(cond) {
    for (var i = 0; i < AppConstants.COND_TABLE_COLOR.length; ++i) {
        if (cond >= AppConstants.COND_TABLE[i]) {
            return SWTResourceManager.getColor(AppConstants.COND_TABLE_COLOR[i]);
        }
    }
    // 0より小さいってあり得ないけど
    return SWTResourceManager.getColor(AppConstants.COND_RED_COLOR);
}

function create(table, data, index) {
    // 艦娘
    var ship = data[0].get();

    var item = new TableItem(table, SWT.NONE);

    item.setData(ship);

    // 偶数行に背景色を付ける
    if ((index % 2) != 0) {
        item.setBackground(SWTResourceManager.getColor(AppConstants.ROW_BACKGROUND));
    }

    // 疲労
    item.setBackground(condIndex, getTableCondColor(ship.cond));

    // 遠征
    if (missionShips.contains(ship.id)) {
        item.setForeground(SWTResourceManager.getColor(AppConstants.MISSION_COLOR));
    }
    // 入渠
    if (ndockShips.contains(ship.id)) {
        item.setForeground(SWTResourceManager.getColor(AppConstants.NDOCK_COLOR));
    }
    // Lv1の艦娘をグレー色にする
    /* ちょっとこれをやる意味がよく分からないのでコメントアウト
    if (ship.getLv() == 1) {
        item.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GRAY));
    }
    */

    item.setText(ReportUtils.toStringArray(data));

    return item;
}

function end() { }
